package com.fuzamei.web;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.fuzamei.constant.HintMSG;
import com.fuzamei.entity.User;
import com.fuzamei.service.SupplierService;
import com.fuzamei.util.JSONUtil;
import com.fuzamei.util.ValidationUtil;

@RestController
@RequestMapping(path="/supplier")
public class SupplierAction {
	@Autowired
	private SupplierService supplierService;
	/**
	   {
         "user_id":"1001",
         "username":"小张"
       }
	 * @param data
	 * @return
	 */
	@PostMapping(value="querySupplier")
	public Map<String, Object> querySupplier(@RequestBody String data){
		try {
			List<User> list=null;
			@SuppressWarnings("unchecked")
			Map<String, Object> map = JSON.parseObject(data,Map.class);//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
			int user_id = ValidationUtil.checkAndAssignInt(map.get("user_id"));//   ————————》给个用户id 判断用户id是什么权限
			
			String username=ValidationUtil.checkBlankStringAndAssignEmptyIfIsBlank(map.get("username"));//拿到前端传来的账号去service校验
			Map<String, Object> mapToService = new LinkedHashMap<String, Object>();
			mapToService.put("user_id",user_id );
			mapToService.put("username", username);
			list=supplierService.querySupplier(mapToService);
			return JSONUtil.getJsonMap(200, true, HintMSG.QUERY_SUCCESS, list);
		} catch (Exception e) {
			e.printStackTrace();
			return JSONUtil.getJsonMap(500, false, HintMSG.QUERY_FAIL+":"+e.getMessage(), null);
		}
	}
	/**
	 * {
	   "supplierId":"1005"
       }
	 * @param data
	 * @return
	 */
	@PostMapping(value="queryPlannerBySupplierId")
	public Map<String, Object> queryPlannerBySupplierId(@RequestBody String data){
		try {
			@SuppressWarnings("unchecked")
			Map<String, Object> map = JSON.parseObject(data,Map.class);//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
			int userId = ValidationUtil.checkAndAssignInt(map.get("supplierId"));// 传的是供应商id    其实就是用户id  
			
		    List<User> PlannerList=supplierService.queryPlannerBySupplierId(userId);
		    return JSONUtil.getJsonMap(200, true, HintMSG.QUERY_SUCCESS, PlannerList);
		} catch (Exception e) {
			e.printStackTrace();
			return JSONUtil.getJsonMap(500, false, HintMSG.QUERY_FAIL+":"+e.getMessage(), null);
		}
	}
		
		
		
	
	
	
}
